<?php
if (!can_access_logs($vbulletin->config['SpecialUsers']['canviewadminlog']))
{
	// We have no perms
	print_cp_no_permission();
}

print_cp_header($vbphrase['dbtech_vbsecurity_ipverify_cp_header']);

// ###################### Start modify #######################
if ($_REQUEST['action'] == 'acplogins' OR empty($_REQUEST['action']))
{
	$users = $db->query_read_slave("
		SELECT DISTINCT ipverify.userid, user.username
		FROM " . TABLE_PREFIX . "dbtech_vbsecurity_ipverify AS ipverify
		LEFT JOIN " . TABLE_PREFIX . "user AS user USING(userid)
		ORDER BY username
	");
	$userlist = array('no_value' => $vbphrase['dbtech_vbsecurity_ipverify_all_log_entries']);
	while ($user = $db->fetch_array($users))
	{		
		$userlist["$user[userid]"] = $user['username'];
	}	
	
	print_form_header('vbsecurity', 'acplogins');
	construct_hidden_code('action', 'view_stats');
	print_table_header($vbphrase['dbtech_vbsecurity_ipverify_table_header']);
	print_input_row('<span style="padding-right:60px;">' . $vbphrase['dbtech_vbsecurity_ipverify_log_entries_to_show_per_page'], 'perpage' . '</span>', 25);
	print_select_row($vbphrase['dbtech_vbsecurity_ipverify_order_by'], 'orderby', array(
		'DESC' 	=> $vbphrase['dbtech_vbsecurity_ipverify_desc'],
		'ASC' 	=> $vbphrase['dbtech_vbsecurity_ipverify_asc']
	));
	print_submit_row($vbphrase['dbtech_vbsecurity_ipverify_show_entries'], 0);

	if (can_access_logs($vbulletin->config['SpecialUsers']['canpruneadminlog'], 1))
	{			
		print_form_header('vbsecurity', 'acplogins');
		construct_hidden_code('action', 'prune_admin_log');
		print_table_header($vbphrase['dbtech_vbsecurity_ipverify_prune_log']);
		print_label_row($vbphrase['dbtech_vbsecurity_ipverify_remove_entries_user'], '<select name="userid" tabindex="1" class="bginput">' . construct_select_options($userlist) . '</select>', '', 'top', 'puserid');
		print_input_row($vbphrase['dbtech_vbsecurity_ipverify_remove_entries_days'], 'daysprune', 30);
		print_submit_row($vbphrase['dbtech_vbsecurity_ipverify_prune_entries'], 0);
	}
}

// ###################### Start view #######################
if ($_REQUEST['action'] == 'view_stats')
{
	$vbulletin->input->clean_array_gpc('r', array(
		'username' => TYPE_STR,
		'userid' => TYPE_STR,
		'perpage'	=> TYPE_UINT,
		'pagenumber' => TYPE_UINT,
		'orderby'	=> TYPE_NOHTML,
		'total' => TYPE_UINT
	));
	
	$sqlconds = array();
	$hook_query_fields = $hook_query_joins = '';
	
	if ($vbulletin->GPC['perpage'] < 1)
	{
		$vbulletin->GPC['perpage'] = 15;
	}
		
	$counter = $db->query_first_slave("
		SELECT COUNT(*) AS total
		FROM " . TABLE_PREFIX . "dbtech_vbsecurity_ipverify

	");
	
	$totalpages = ceil($counter['total'] / $vbulletin->GPC['perpage']);
	
	if ($vbulletin->GPC['pagenumber'] < 1)
	{
		$vbulletin->GPC['pagenumber'] = 1;
	}
	$startat = ($vbulletin->GPC['pagenumber'] - 1) * $vbulletin->GPC['perpage'];
	
	$order = ' ipverifyid ' . $vbulletin->GPC['orderby'];	
	
	$logs = $db->query_read_slave("
		SELECT ipverify.*, user.username
		FROM " . TABLE_PREFIX . "dbtech_vbsecurity_ipverify AS ipverify
		INNER JOIN " . TABLE_PREFIX . "user AS user ON (ipverify.userid = user.userid)
		ORDER BY $order
		LIMIT $startat, " . $vbulletin->GPC['perpage'] . "

	");		
	
	if ($db->num_rows($logs))
	{
		if ($vbulletin->GPC['pagenumber'] != 1)
		{
			$prv = $vbulletin->GPC['pagenumber'] - 1;
			$firstpage = "<input type=\"button\" class=\"button\" value=\"&laquo; " . $vbphrase['dbtech_vbsecurity_ipverify_first_page'] . "\" tabindex=\"1\" onclick=\"window.location='vbsecurity.php?" . $vbulletin->session->vars['sessionurl'] . "do=acplogins&action=view_stats&bounce=" . $vbulletin->GPC['bounce'] . "&pp=" . $vbulletin->GPC['perpage'] . "&orderby=" . $vbulletin->GPC['orderby'] . "&page=1'\">";
			$prevpage = "<input type=\"button\" class=\"button\" value=\"&lt; " . $vbphrase['dbtech_vbsecurity_ipverify_prev_page'] . "\" tabindex=\"1\" onclick=\"window.location='vbsecurity.php?" . $vbulletin->session->vars['sessionurl'] . "do=acplogins&action=view_stats&bounce=" . $vbulletin->GPC['bounce'] . "&pp=" . $vbulletin->GPC['perpage'] . "&orderby=" . $vbulletin->GPC['orderby'] . "&page=$prv'\">";
		}
	
		if ($vbulletin->GPC['pagenumber'] != $totalpages)
		{
			$nxt = $vbulletin->GPC['pagenumber'] + 1;
			$nextpage = "<input type=\"button\" class=\"button\" value=\"" . $vbphrase['dbtech_vbsecurity_ipverify_next_page'] . " &gt;\" tabindex=\"1\" onclick=\"window.location='vbsecurity.php?" . $vbulletin->session->vars['sessionurl'] . "do=acplogins&action=view_stats&bounce=" . $vbulletin->GPC['bounce'] . "&pp=" . $vbulletin->GPC['perpage'] . "&orderby=" . $vbulletin->GPC['orderby'] . "&page=$nxt'\">";
			$lastpage = "<input type=\"button\" class=\"button\" value=\"" . $vbphrase['dbtech_vbsecurity_ipverify_last_page'] . " &raquo;\" tabindex=\"1\" onclick=\"window.location='vbsecurity.php?" . $vbulletin->session->vars['sessionurl'] . "do=acplogins&action=view_stats&bounce=" . $vbulletin->GPC['bounce'] . "&pp=" . $vbulletin->GPC['perpage'] . "&orderby=" . $vbulletin->GPC['orderby'] . "&page=$totalpages'\">";
		}
		
		$headings = array();
		$headings[] = $vbphrase['id'];
		$headings[] = $vbphrase['username'];
		$headings[] = $vbphrase['ip_address'];
		$headings[] = $vbphrase['date'];
	
		print_form_header('', '');
		print_description_row(construct_link_code($vbphrase['dbtech_vbsecurity_ipverify_restart_search'], "vbsecurity.php?" . $vbulletin->session->vars['sessionurl'] . "do=acplogins"), false, count($headings), 'thead', 'right');
		print_table_header(construct_phrase($vbphrase['dbtech_vbsecurity_ipverify_list_page_x_y_there_are_z_total_log_entries'], vb_number_format($vbulletin->GPC['pagenumber']), vb_number_format($totalpages), vb_number_format($counter['total'])), count($headings));
		print_cells_row($headings, 1);

		while ($log = $db->fetch_array($logs))
		{
			$cell = array();
			$cell[] = $log['ipverifyid'];
			$cell[] = "<a href=\"" . $vbulletin->options['bburl'] . "/member.php?u=$log[userid]\" target=\"_blank\">$log[username]</a>";
			$cell[] = '<span class="smallfont">' . iif($log['ipaddress'], "<a href=\"usertools.php?" . $vbulletin->session->vars['sessionurl'] . "do=gethost&ip=$log[ipaddress]\">$log[ipaddress]</a>", '&nbsp;') . '</span>';
			$cell[] = '<span class="smallfont"><center>' . vbdate($vbulletin->options['logdateformat'], $log['dateline']) . '</center></span>';
	
			print_cells_row($cell, false, false, 0, 'top', false, true);
		}
	
		print_table_footer(count($headings), "$firstpage $prevpage &nbsp; $nextpage $lastpage");
	}
	else
	{
		print_stop_message('dbtech_vbsecurity_ipverify_no_results');
	}
}

// ###################### Start prune log #######################
if ($_REQUEST['action'] == 'prune_admin_log' AND can_access_logs($vbulletin->config['SpecialUsers']['canpruneadminlog'], '<p>' . $vbphrase['dbtech_vbsecurity_ipverify_restricted'] . '</p>'))
{
	$vbulletin->input->clean_array_gpc('r', array(
		'userid'	=> TYPE_INT,
		'daysprune'	=> TYPE_INT
	));

	$datecut = TIMENOW - (86400 * $vbulletin->GPC['daysprune']);
	$query = "SELECT COUNT(*) AS total FROM " . TABLE_PREFIX . "dbtech_vbsecurity_ipverify WHERE dateline < $datecut";

	if ($vbulletin->GPC['userid'])
	{
		$query .= "\nAND userid = " . $vbulletin->GPC['userid'];
	}

	$logs = $db->query_first_slave($query);
	if ($logs['total'])
	{
		print_form_header('vbsecurity', 'acplogins');
		construct_hidden_code('action', 'do_prune_admin_log');
		construct_hidden_code('datecut', $datecut);
		construct_hidden_code('userid', $vbulletin->GPC['userid']);
		print_table_header($vbphrase['dbtech_vbsecurity_ipverify_prune_log_header']);
		print_description_row(construct_phrase($vbphrase['dbtech_vbsecurity_ipverify_prune_verify'], vb_number_format($logs['total'])));
		print_submit_row($vbphrase['dbtech_vbsecurity_ipverify_yes'], 0, 0, $vbphrase['dbtech_vbsecurity_ipverify_no']);
	}
	else
	{
		print_stop_message('dbtech_vbsecurity_ipverify_no_results');
	}

}

// ###################### Start do prune log #######################
if ($_POST['action'] == 'do_prune_admin_log' AND can_access_logs($vbulletin->config['SpecialUsers']['canpruneadminlog'], '<p>' . $vbphrase['dbtech_vbsecurity_ipverify_restricted'] . '</p>'))
{
	$vbulletin->input->clean_array_gpc('p', array(
		'userid'	=> TYPE_INT,
		'datecut'	=> TYPE_INT
	));


	$query = "DELETE FROM " . TABLE_PREFIX . "dbtech_vbsecurity_ipverify WHERE dateline < " . $vbulletin->GPC['datecut'];

	if ($vbulletin->GPC['userid'])
	{
		$query .= "\nAND userid = " .  $vbulletin->GPC['userid'];
	}

	$db->query_write($query);

	define('CP_REDIRECT', 'vbsecurity.php?do=acplogins');
	print_stop_message('dbtech_vbsecurity_ipverify_pruned_successfully');
}

print_cp_footer();
?>